package vt.cs.virtSchool.labapplets.BlockAndPlane;
import java.awt.*;
import java.lang.Float;

public class PlaneDialog extends Dialog {

Button Cancel = new Button("Cancel");
Button Ok	    = new Button("Ok");
Plane  plane  = null;
Label HeightLabel      = null;
TextField HeightField  = null;
Label LengthLabel      = null;
TextField LengthField  = null;
Label AngleLabel       = null;
TextField AngleField   = null;
Label MuSLabel         = null;
TextField MuSField     = null;
Label MuKLabel         = null;
TextField MuKField     = null;

  BlockAndPlane bnp = null;

public PlaneDialog(Plane p, Frame parentFrame, BlockAndPlane bnp) {
   super(parentFrame, "Change Plane Parameters", false);
   this.bnp = bnp;
   plane = p;   
   Panel p1 = new Panel();
   p1.setLayout(new GridLayout(0,2));
   // Height
   HeightLabel = new Label("Height: (m) ",Label.LEFT);
   Float f = new Float(plane.getHeight());
   HeightField = new TextField(f.toString(),10);
   p1.add(HeightLabel);
   p1.add(HeightField);
   // Length
   LengthLabel = new Label("Length: (m) ",Label.LEFT);
   f = new Float(plane.getLength());
   LengthField = new TextField(f.toString(),10);
   p1.add(LengthLabel);
   p1.add(LengthField);
   // Angle
   AngleLabel = new Label("Angle: (deg) ",Label.LEFT);
   // CONVERT TO DEGREES FOR DISPLAY   
   f = new Float(plane.getAngle() * 180 / java.lang.Math.PI);
   AngleField = new TextField(f.toString(),10);
   p1.add(AngleLabel);
   p1.add(AngleField);
   // MuS
   MuSLabel = new Label("MuS: ",Label.LEFT);
   f = new Float(plane.getMuS());
   MuSField = new TextField(f.toString(),10);
   p1.add(MuSLabel);
   p1.add(MuSField);
   // MuK
   MuKLabel = new Label("MuK: ",Label.LEFT);
   f = new Float(plane.getMuK());
   MuKField = new TextField(f.toString(),10);
   p1.add(MuKLabel);
   p1.add(MuKField);

   p1.add(Ok);
   p1.add(Cancel);

   setLayout(new GridLayout(0,1));
   add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}
  public boolean keyUp(Event event, int key) {
Float f1 = null,f2 = null;
Double d = null;
   if ((event.target == HeightField) || (event.target == LengthField)) {
      f1 = new Float(HeightField.getText());
      f2 = new Float(LengthField.getText());
      d =  new Double((180 / java.lang.Math.PI)*Math.atan((double)f1.floatValue()/(double)f2.floatValue()));
      AngleField.setText(d.toString());
   }
   if (event.target == AngleField) {
      f1 = new Float(LengthField.getText());
      f2 = new Float(AngleField.getText());
      // CONVERT TO DEGREES FOR DISPLAY
      f2 = new Float((java.lang.Math.PI/180)*f2.floatValue());
      d = new Double((double)f1.floatValue()*Math.tan((double)f2.floatValue()));
      HeightField.setText(d.toString());
   }
   return false;
  }

  public boolean action(Event event, Object arg) {
    if (event.target == Cancel){
      hide();
      bnp.refresh();
      return true;
    }
    if (event.target == Ok) {
      debug("Height = "+HeightField.getText()+
	    " Length = "+LengthField.getText() +
	    " Angle = "+AngleField.getText() +
	    " MuS = " + MuSField.getText() +
	    " MuK = " + MuKField.getText());
      
      plane.setLength((Float.valueOf(LengthField.getText())).floatValue());
      // CONVERT FROM DEGREES FOR STORAGE
      plane.setHeight((Float.valueOf(HeightField.getText())).floatValue());
      plane.setAngle((float)(java.lang.Math.PI/180)*
		     (Float.valueOf(AngleField.getText())).floatValue());
      plane.setMuS((Float.valueOf(MuSField.getText())).floatValue());
      plane.setMuK((Float.valueOf(MuKField.getText())).floatValue());
      debug("pre Hide");
      hide();
      debug("post Hide");
      bnp.refresh();
      return true;
    } 
    return false; 
  }

  private static  final boolean debug = false;
  private void debug(String msg) {
    if (debug)
      System.out.println(getClass().getName()+": "+msg);
  }
}
