/*
 *
 * Written By: 	Michael Parks
 * Date:			6/23/96
 * Description:	Surface SuperClass
 *
 * Usage Notes:
 *
 * 
 */
  
/*
 *
 * Copyright (c) 1996 Michael Parks. All Rights Reserved.
 *
 * 
 */
package vt.cs.virtSchool.labapplets.BlockAndPlane;

import java.awt.*;
import vt.cs.shareablePrimitive.*;
import SharedData.*;


public abstract class Surface {
  // all units of length in meters
  /*
    protected float height = 0;	
    protected float length = 0;
   protected float SurfaceLength = 0;
   protected float MuS = 0; 		// Coefficient of Static Friction
   protected float MuK = 0; 		// Coefficient of Kinetic Friction
   protected float MuR = 0; 		// Coeffienent of Static Rolling Friction
   protected float angle = 0; 		// Angle in Radians
  */
  protected ShareableFloat height = null;
  protected ShareableFloat length = null;
  protected ShareableFloat MuS = null;   // Coefficient of Static Friction
  protected ShareableFloat MuK = null;   // Coefficient of Kinetic Friction
  protected ShareableFloat MuR = null;   // Coeffienent of Static Rolling Friction
  //protected ShareableFloat angle = null; // Angle in Radians
  protected float angle = 0; 		// Angle in Radians

  //  protected ShareableFloat SurfaceLength = null;
  protected float SurfaceLength = 0;


   protected int   LeftEnd = 0; 		// Ends of plane in pixels
   protected int   RightEnd = 0;
   protected Polygon PlanePoly = null;

    public Surface(float ht,
		   float lngth,
		   float NewMuS,
		   float NewMuK,
		   float NewMuR,
		   int StartPos) {
      this(ht, lngth, NewMuS, NewMuK, NewMuR, StartPos, null, null, "NoName");
    }
   
    public Surface(float ht,
		   float lngth,
		   float NewMuS,
		   float NewMuK,
		   float NewMuR,
		   int StartPos,
		   Session session,
		   Client client,
		   String name) {
      //StartPos is the leftmost end of the plane, in pixels
      /*
	height = ht;
	length = lngth;
	MuS = NewMuS;
	MuK = NewMuK;
	MuR = NewMuR;
      */

      height = new ShareableFloat(name+"Height", session, client, ht);
      length = new ShareableFloat(name+"Length", session, client, lngth);
      MuS = new ShareableFloat(name+"MuS", session, client, NewMuS);
      MuK = new ShareableFloat(name+"MuK", session, client, NewMuK);
      MuR = new ShareableFloat(name+"MuR", session, client, NewMuR);

      LeftEnd  = StartPos;      
      RightEnd = StartPos + (int)(lngth * SimCanvas.ScaleFactor);
      init();
   }
   protected void init() {

      float HypSqrd;
      HypSqrd = (getLength()*getLength()) + 
	(getHeight()*getHeight());
      SurfaceLength = (float)Math.sqrt(HypSqrd);
      angle = (float)Math.atan((double)getHeight()/getLength());
      PlanePoly = null;
      RightEnd = LeftEnd + Math.round(getLength()*SimCanvas.ScaleFactor);
   }

   public abstract void paint(Graphics g,Dimension d);  
 
   public void setHeight(float NewHeight) {
      height.setValue(NewHeight);
      init();
   }
   public float getHeight() {
     return height.floatValue();
   }

   public void setLength(float NewLength) {
       length.setValue(NewLength);
   }

   public float getLength() {
     return length.floatValue();
   }

   public void setAngle(float NewAngle) {
      angle = NewAngle;
      height.setValue((float)(getLength() * Math.tan((double)angle)));
   }

   public float getAngle() {
     return angle;
   } 

   public float getSurfaceLength() {
     return SurfaceLength;
   }

   public void setMuS(float NewMuS) {
     MuS.setValue(NewMuS);
   }

   public float getMuS() {
     return MuS.floatValue();
   }

   public void setMuK(float NewMuK) {
     MuK.setValue(NewMuK);
   }

   public float getMuK() {
     return MuK.floatValue();
   }

   public void setMuR(float NewMuR) {
     MuR.setValue(NewMuR);
   }

   public float getMuR() {
     return MuR.floatValue();
   }

   public void setLeftEnd(int NewLeftEnd) { 
     //Set in pixels
     LeftEnd = NewLeftEnd;
     RightEnd =(int)(LeftEnd + (getLength()*SimCanvas.ScaleFactor));
   }

   public void setLeftEnd(float NewLeftEnd) { //Set in meters
      LeftEnd = (int)(NewLeftEnd*SimCanvas.ScaleFactor);
      RightEnd = (int)(LeftEnd + (getLength()*SimCanvas.ScaleFactor));
   }

   public float getLeftEnd() { // Get Left End in meters
      return((float)((float)LeftEnd/(float)SimCanvas.ScaleFactor));
   }

  public float getRightEnd() { // Get Right End in meters
      return((float)((float)RightEnd/(float)SimCanvas.ScaleFactor));
  }

   public boolean inside(float position) {
      if (((position*SimCanvas.ScaleFactor) >= LeftEnd) 
      &&  ((position*SimCanvas.ScaleFactor) < RightEnd))
         return true;
      else 
         return false;
   }
}
