package vt.cs.virtSchool.labapplets.Graph;

import java.awt.*;
import java.util.*;
import vt.cs.db.*;

public class Legend extends Frame{

  G2Dint graph;
  Vector cbVector;
  Vector daVector;
  Choice axisChoice;
  Axis xaxis;
  Axis yaxis;
  Table table;

  String oldchoice;

  Font font = new Font("TimesRoman", Font.ITALIC + Font.BOLD, 15);

  public Legend(String str){
    super(str);
    setFont(font);
    setBackground(Color.lightGray);
  }

  public void setReferences( 
		G2Dint gph, //Graph class, needed to control what is drawn in graph
		Vector vcb, //Vector of checkboxes)
		Vector vda, //Vector of data and attributes
		Choice achoice,
		Table tbl,
		Axis xax,
		Axis yax)
  {
    graph = gph;
    cbVector = vcb;
    daVector = vda;
    axisChoice = achoice;
    xaxis = xax;
    yaxis = yax;
    table = tbl;
    
    oldchoice = axisChoice.getSelectedItem();
  }
  
  public boolean action(Event ev, Object arg) {
    //check for checklabel checkbox events
    for (int x = 0; x < cbVector.size(); x++) {
      if (ev.target.equals(cbVector.elementAt(x))){ 
	if (!((Checkbox)(cbVector.elementAt(x))).getState()){
	  graph.hideDataSet((vt.cs.virtSchool.labapplets.Graph.DataSet)daVector.elementAt(x));
	  //graph.detachDataSet((vt.cs.virtSchool.labapplets.Graph.DataSet)daVector.elementAt(x));
	}
	else {
	  graph.showDataSet((vt.cs.virtSchool.labapplets.Graph.DataSet)daVector.elementAt(x));
	  //graph.attachDataSet((vt.cs.virtSchool.labapplets.Graph.DataSet)daVector.elementAt(x));
	}
	//System.out.println("Checkbox: " + x +"  Status: " + ((Checkbox)(cbVector.elementAt(x))).getState());
	graph.repaint();
	return true;
      }
    }
    if(ev.target.equals(axisChoice)) {
      //System.out.println("choice: " + (String)arg);
      if ((String)arg != oldchoice) {
	//System.out.println("Old choice: "+ oldchoice +" New choice: "+
	//axisChoice.getSelectedItem());
	oldchoice = axisChoice.getSelectedItem();
	xaxis.setTitleText(axisChoice.getSelectedItem());
	recalculateGraph();
	graph.repaint();
      }
    }
    return true;
  }
  

  /*****
   ** Overrides the minimumSize method.
   *****/
  public synchronized Dimension minimumSize(){
    int height = 50*(cbVector.size() + 1);
    Dimension dim = new Dimension(200, height);
    return dim;
  }

  private void recalculateGraph() {
    
    int i,j, key;
    Vector points = new Vector();
    vt.cs.virtSchool.labapplets.Graph.DataSet datain;
    daVector = new Vector();
    
    //System.out.println("axisChoice size: " +axisChoice.countItems());
    graph.detachDataSets(); //remove all data sets for the graph
    xaxis.detachAll();
    yaxis.detachAll();
    
    for (key=0; key < axisChoice.countItems(); key++) {
      //System.out.println("table rowcount: " + table.rowcount());
      double data[] = new double[2*(int)table.rowcount()];
      try {
	for (i=j=0; i<table.rowcount(); i++, j+=2) {
	  data[j+1] = ((Number)table.get(i, axisChoice.getItem(key))).doubleValue();
	  data[j] = ((Number)table.get(i, axisChoice.getSelectedItem())).doubleValue();
	  //System.out.println("Plotting (" + data[j] + ", " + data[j+1] + ")");
	}
      } catch(Exception e) {e.printStackTrace();}
      
      //sets up graph attributes for data
      
      datain = graph.loadDataSet(data, (int)table.rowcount());
      datain.linestyle = 1;
      datain.linecolor = LegendColor.getSomeColor(key);
      datain.marker    = 1;
      datain.markerscale = 1.5;
      datain.markercolor = new Color(0, 0, 255);
      
      daVector.addElement(datain);
      
      xaxis.attachDataSet(datain); //attach appropriate data to x and y
      yaxis.attachDataSet(datain);
      
      if (((Checkbox)(cbVector.elementAt(key))).getState() == false) {
	//((Checkbox)(cbVector.elementAt(key))).setState(true);
	graph.hideDataSet((vt.cs.virtSchool.labapplets.Graph.DataSet)daVector.elementAt(key));
      }
    }
  }
  
}
