package vt.cs.virtSchool.labapplets.Graph;

import vt.cs.db.*;

import java.awt.*;
import java.lang.*;
import java.applet.*;
import java.util.*;

public class SelectFrame extends Frame{

  final static int DBSET = 0;

  Graph app;
  DatabaseSet dbSet;
  Database    db;
  Table       table;

  String dbsetURL;
  String dbURL;
  String tableURL;

  List  m_DatabaseList;
  List  m_TableList;

  Button graphBtn;
  Button updateBtn;

  QueryDialog qd;

  String graphTitle;

  int Current_Query = DBSET;
  
  Panel choice;

  public boolean notnull;

  public SelectFrame(String dbs, String d, String t, Graph ap){
    super("Select");
    dbsetURL = dbs;
    dbURL = d;
    tableURL = t;
    app = ap;
    notnull = false;
    if(dbsetURL != null){
      create();
    }else{
      qd = new QueryDialog(this, 60, "Enter location of database set.");
      qd.resize(600, 150);
      qd.show();
    }
  }
  
  public void textEntered(String str) {
    try {
      switch (Current_Query) {
      case DBSET: 
	dbsetURL = str;
	//System.out.println("set dbset text");
	create();
	break;
      default:
	//System.out.println("No current query");
	break;
      }
    }	catch (Exception e) { e.printStackTrace();}
  }
	

  private void create(){
    choice = new Panel();
    boolean graphNow = false;

    choice.setLayout(new GridLayout(1,2));

    try {
      if(dbsetURL != null){
	dbSet = Manager.getDatabaseSet(dbsetURL);
	if(dbSet != null){
	  m_DatabaseList = new List(4, false);
	  String[] dbs = dbSet.getDatabases();
	  for(int n=0; n<dbs.length; n++){
	    m_DatabaseList.addItem(dbs[n]);
	    if (dbs[n].equals(dbURL)){
	      m_DatabaseList.select(n);
	    }
	  }
	  if(m_DatabaseList.getSelectedItem() == null){
	    m_DatabaseList.select(0);
	  }
	  db = dbSet.getDatabase(m_DatabaseList.getSelectedItem());
	  if(db != null){
	    notnull = true; 
	    m_TableList = new List(4, false);
	    String[] tbs = db.getTables();
	    for(int n=0; n<tbs.length; n++){
	      m_TableList.addItem(tbs[n]);
	      if(tbs[n].equals(tableURL)){
		graphTitle = tbs[n];
		m_TableList.select(n);
		graphNow = true;
		//System.out.println("graphNow true");
	      }
	    }
	    //System.out.println("selected table: " + m_TableList.getSelectedItem());
	    if(m_TableList.getSelectedItem() == null){
	      m_TableList.select(0);
	    }
	    table = db.getTable(m_TableList.getSelectedItem());
	    //if(graphNow == true){
	    //app.graphSelectedTable(table);
	      //System.out.println("parameter \"table\" given");
	      //hide();
	      //return;
	    // }
	  }	 
	  choice.add(m_DatabaseList);
	  choice.add(m_TableList);
	  graphBtn = new Button("Graph");
	  updateBtn = new Button("Update");
	  
	  setLayout(new BorderLayout());
	  add("North", updateBtn);
	  add("Center", choice);
	  add("South", graphBtn);
	  resize(300, 200);
	  if(graphNow == true){
	    app.graphSelectedTable(table, graphTitle);
	  }
	  else{
	    show();
	  }
	}
      }
    }catch(Exception e){
      AlertDialog ad = new AlertDialog(this, "Unable to locate specified data base set.");
      ad.resize(300, 100);
      ad.show();
      //e.printStackTrace();
    }
  }
  
  public boolean handleEvent(Event evt){
    if(evt.target.equals(m_DatabaseList) && (evt.id == Event.LIST_SELECT)){
      //System.out.println("Database select");
      if(dbSet != null){
	db = dbSet.getDatabase(m_DatabaseList.getSelectedItem());	
	if(db != null){
	  if(m_TableList != null){
	    choice.remove(m_TableList);
	  }
	  notnull = true; 
	  m_TableList = new List(4, false);
	  String[] tbs = db.getTables();
	  for(int n=0; n<tbs.length; n++){
	    m_TableList.addItem(tbs[n]);	    		
	  }
	  m_TableList.select(0);
	  table = db.getTable(m_TableList.getSelectedItem());	 
	}	 
	choice.add(m_TableList);	
      }
      return true;
    }else if(evt.target.equals(m_TableList) && (evt.id == Event.LIST_SELECT)){
      //System.out.println("Table select");
      if(db != null){
	table = db.getTable(m_TableList.getSelectedItem());
      }
      return true;
    }else if(evt.id == Event.ACTION_EVENT){
      action(evt, evt.arg);
      return true;
    }else{
      return false;
    }
  }

  public boolean action(Event evt, Object arg){
    if(arg.equals("Graph")){
      //System.out.println("Graph Button");
      graphTitle = m_TableList.getSelectedItem();
      app.graphSelectedTable(table, graphTitle); 
      hide();  
      return true;
    }
    else if(arg.equals("Update")){
      if((table != null) && (db != null)){
	choice.remove(m_TableList);
	m_TableList = new List(4, false);
	String[] tbs = db.getTables();
	for(int n=0; n<tbs.length; n++){
	  m_TableList.addItem(tbs[n]);
	}
	m_TableList.select(0);
	table = db.getTable(m_TableList.getSelectedItem());
	choice.add(m_TableList);
	validate();
	return true;
      }
      return false;
    }else{
      return false;
    }
  } 
  
}



