/*
 *
 * Written By: Philip Isenhour
 * Date:       21 August 1996
 * Descriptions: Simple meter consumer using Needle class written
 *					by Liam Relihan <relihanl@ul.ie>
 *
 */
 
/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/labapplets/Meter/Meter.java,v 1.3 1996/09/23 16:21:40 isenhour Exp $
 * Copyright (c) 1996 Philip Isenhour
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package vt.cs.virtSchool.labapplets.Meter;
import vt.cs.virtSchool.util.*;
import vt.cs.virtSchool.objectManager.ObjectManager;
import vt.cs.widgets.Needle;

import java.awt.*;
import java.lang.*;
import java.applet.*;
import java.util.*;

import java.rmi.Remote;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.Naming;

public class Meter extends Applet implements Runnable {
	Needle 			meter = null;
	Thread 			thd = null;

	String			dataLabel = "";
	ConsumerStream	data = null;

	Choice			streamChoice = new Choice();

	public void init() { 
		setLayout(new BorderLayout());

		Vector  keys = ConsumerStream.getLabelsByType(this, "java.lang.Long");
		// Need to handle the case where no keys are found...
		dataLabel = (String)keys.firstElement();
		data = new ConsumerStream(dataLabel);

		for (Enumeration e = keys.elements(); e.hasMoreElements();)
			streamChoice.addItem((String)e.nextElement());
		add("North", streamChoice);

		meter = new Needle(-250.0, 250.0, 25.0, 0.0);
		meter.setCaptionFont(new Font("Times", Font.PLAIN, 20));
		meter.setCaption(dataLabel);
		add("Center", meter);

		// Ignore values already present when the meter is started
		Vector 	points = data.getAllValues();
	}
  

	public void start(){
		thd = new Thread(this);
		thd.start();
	}

	public void stop() { 
		thd.stop(); 
	}
  
	public synchronized void run(){
		while (true)
			getValue();
	}  

	synchronized void getValue() {
		Long value = (Long)(data.getNext().value());
   	   	meter.setValue(value.doubleValue());
	}

    public boolean handleEvent(Event e) {
        if (e.id == Event.WINDOW_DESTROY)
            System.exit(0);
		if ((e.id == Event.ACTION_EVENT) && (e.target == streamChoice)) {
			dataLabel = (String)e.arg;
			data = new ConsumerStream(dataLabel);
			Vector garbage = data.getAllValues();
			meter.setCaption(dataLabel);
			return true;
		}
        return false;
    }

}


