
package vt.cs.virtSchool.labapplets.WhiteBoard;

import java.io.*;
import SharedData.*;
import netscape.application.*;

public class WhiteBoardMessage implements Serializable {
	public static final int WHITEBOARD_ADD				= 0;
	public static final int WHITEBOARD_UPDATE			= 1;
	public static final int WHITEBOARD_MOVE				= 2;
	public static final int WHITEBOARD_REMOVE			= 3;
	public static final int WHITEBOARD_SET_FILL_COLOR	= 4;
	public static final int WHITEBOARD_SET_STROKE_COLOR	= 5;

	public 	int			type		= -1;
	public	String		tool		= null;
	public	String		id			= null;
	public	int			x			= -1;
	public	int			y			= -1;
	public	int			operation	= -1;
	public	int			rgb			= -1;

	public WhiteBoardMessage(int type, String id, String tool, int operation,
		int x, int y) {
		this.type = type;
		this.id = id;
		this.tool = tool;
		this.x = x;
		this.operation = operation;
		this.y = y;
	}

	public WhiteBoardMessage(int type, String id, int rgb) {
		this.type = type;
		this.id = id;
		this.tool = "";
		this.rgb = rgb;
	}

	public static WhiteBoardMessage messageFromByteArray(byte[] data) {
		ByteArrayInputStream	byteArrayStream = null;
		ObjectInputStream		objectStream	= null;
		WhiteBoardMessage		msg				= null;

		try {
			byteArrayStream = new ByteArrayInputStream(data);
			objectStream = new ObjectInputStream(byteArrayStream);

			msg = (WhiteBoardMessage)objectStream.readObject();
		}
		catch(Exception e) {
			e.printStackTrace();
		}

		return msg;
	}

	public static WhiteBoardMessage messageFromData(Data data) {
		return messageFromByteArray(data.getData());
	}

	public static byte[] toByteArray(Object obj) {
		ByteArrayOutputStream	byteArrayStream = null;
		ObjectOutputStream		objectStream	= null;
		byte[]					bytes			= null;

		try {
			byteArrayStream = new ByteArrayOutputStream();
			objectStream = new ObjectOutputStream(byteArrayStream);

			objectStream.writeObject(obj);
			bytes = byteArrayStream.toByteArray();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		return bytes;
	}

	public Data toData() {
		return new Data(toByteArray(this));
	}

}

