/*
 *
 * Written By:   James "Bo" Begole
 * Date:         6 July 1996
 * Description:  Remote Object Interface for Reaction Timer Data
 *
 * Usage Notes:
 *
 */
 
/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/util/DataSets.java,v 1.4 1996/09/18 20:07:54 isenhour Exp $
 *
 * Copyright (c) 1996 James "Bo" Begole
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */

package vt.cs.virtSchool.util;

import vt.cs.virtSchool.objectManager.*;

import java.util.*;

/**
 * This interface may be replaced soon and should NOT be used directly
 * by producer or consumer applets. vt.cs.virtSchool.util.ConsumerStream
 * and vt.cs.virtSchool.util.ProducerStream should be used instead. See
 * vt.cs.virtSchool.labapplets.Collision and 
 * vt.cs.virtSchool.labapplets.Meter for examples.
 */
public interface DataSets extends java.rmi.Remote {

  // Producer Methods
  public void addDataSet(String dataSetName, DataSet dataSet) throws java.rmi.RemoteException;

  //  public void addDataSet(String dataSetName, ObjectManager objectManager) throws java.rmi.RemoteException;

  public void removeDataSet(String dataSetName) throws java.rmi.RemoteException;

  // Consumer Methods
  public Vector getPoints() throws java.rmi.RemoteException;	

  public boolean newData() throws java.rmi.RemoteException;

  public long maxValue() throws java.rmi.RemoteException;

  public long minValue() throws java.rmi.RemoteException;

  public Vector get(String key) throws java.rmi.RemoteException;

  public Vector getKeys(String typeName) throws java.rmi.RemoteException;
}
