/*
 * Written By:   James "Bo" Begole
 * Date:         5 June 1996
 * Description:  Session Accessor interface.
 *
 * Usage Notes:
 *
 * 
 */
 
/*
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/worldClient/SessionAccessor.java,v 1.1.1.1 1996/09/17 05:23:16 isenhour Exp $
 * Copyright (c) 1996 James "Bo" Begole, Craig Struble
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package vt.cs.virtSchool.worldClient;  // virtSchool.util;

import como.sys.User;
import vt.cs.virtSchool.worldClient.IrcChan;



/**
  A SessionAccessor is an object that knows how to join a session
  */

public interface SessionAccessor {
  /**
   * joinSession() joins or creates a session
   */
  public void joinSession(String sessionName);

  /**
   * startCommunication() starts a new commlet and invites the users[]
   * 
   */
  public void startCommunication(String commletname, User users[], String topic );


  /**
   * Return all users using our Programm, i.e. all that are connected
   * to the IRCServer and who are in "pattern"
   */
  public  User[] getUsers( String pattern, boolean como_only );


  /**
   * Return all the channels (matching pattern)
   */
  public  IrcChan[] getChannels( String patterny );


}

