/*
 * %W% %E%  James Bo Begole
 *
 * Copyright (c) 1997 James Begole,  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. James Begole 
 * SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
package vt.cs.widgets;

import java.util.StringTokenizer;
import java.awt.Color;

/*
 * A multiuser version of RadarPane
 * @version 	$Revision: 1.5 $
 * @author      James Begole
 */

public class MURadarPane extends RadarPane {

  private static String revisionString = "$Revision: 1.5 $";
  { // Strip the '$' character from the revisionString
    StringTokenizer st = new StringTokenizer(revisionString, "$");
    revisionString = st.nextToken();
  }

  private void copyright() {
    System.out.println(getClass().getName()+": "+revisionString+"\n"+
	    "  (c) copyright 1997, James Begole, All rights reseverd.\n"+
	    "  Permission is granted to use this class unmodified.");
  }
  
  protected MURadarPaneParent muparent = null;
  /**
   * Create a new MURadarPane container with a scrollbar display
   * policy of "as needed". 
   */
  public MURadarPane(MURadarPaneParent muparent) {
    this(RadarPane.SCROLLBARS_AS_NEEDED, muparent);
  }

  /**
   * Create a new RadarPane container.
   * @param scrollbarDisplayPolicy  policy for when scrollbars should 
   * be shown
   */
  public MURadarPane(int scrollbarDisplayPolicy, MURadarPaneParent muparent) {
    super(scrollbarDisplayPolicy);
    this.muparent = muparent;
    radarView.setMURadarPaneParent(muparent);
  }

  public void addParticipant(Object key, RadarViewPort viewPort) {
    radarView.addParticipant(key, viewPort);
  }
  public void addLocalViewPort(RadarViewPort viewPort) {
    radarView.addLocalViewPort(viewPort);
  }

  public void removeParticipant(Object key) {
    radarView.removeParticipant(key);
  } 

  public void setLocalUserColor(Color color) {
    radarView.setLocalUserColor(color);
  }


  public void setDrawCursors(boolean value) {
    radarView.setDrawCursors(value);
  }
  public void setDrawLabels(boolean value) {
    radarView.setDrawLabels(value);
  }
}
